/* This is a little program to allow Sheets to launch subprocesses that
 * are useful.  Usage: 
 *
 *    wrapper.exe program args
 *
 * wrapper.exe will perform a little Windows black magic, then launch
 * program with the arguments you gave.  Without wrapper.exe, the
 * output of the program's subprocesses won't go to stdio.
 */

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

static void lose(char *message)
{
	fprintf(stderr, "%s\n", message);
	exit(1);
}

int main(int argc, char *argv[])
{
    STARTUPINFO info;
	PROCESS_INFORMATION pi;
	DWORD result;
	char command[1024];
	int i;

	if (argc < 2)
		lose("usage: wrapper command args...");

	strcpy(command, argv[1]);
	for (i = 2; i < argc; i++) {
		strcat(command, " ");
		strcat(command, argv[i]);
	}

	info.cb = sizeof(info);
	info.lpReserved = NULL;
	info.lpDesktop = NULL;
	info.lpTitle = NULL;
	info.dwFlags = STARTF_USESTDHANDLES;
	info.cbReserved2 = 0;
	info.lpReserved2 = 0;
	info.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
	info.hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);
	info.hStdError = GetStdHandle(STD_OUTPUT_HANDLE);

    if (!CreateProcess(NULL, command, NULL, NULL, TRUE,
		               CREATE_NO_WINDOW, NULL, NULL, &info, &pi))
		lose("CreateProcess failed");

	if (!CloseHandle(pi.hThread))
		lose("CloseHandle(thread) failed");
		
	result = WaitForSingleObject(pi.hProcess, INFINITE);
	if (result == WAIT_FAILED)
		lose("WaitForSingleObject failed");

	if (!GetExitCodeProcess(pi.hProcess, &result))
		lose("GetExitCodeProcess failed.");

	CloseHandle(pi.hProcess);

	return result;
}
